// TestDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TestDemo.h"
#include "TestDemoDlg.h"

#include "DataFile.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestDemoDlg dialog

CTestDemoDlg::CTestDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestDemoDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestDemoDlg)
	DDX_Control(pDX, IDC_STATIC_TOTALLINES, m_TotalLines);
	DDX_Control(pDX, IDC_EDIT_LINENUM, m_LineNum);
	DDX_Control(pDX, IDC_EDIT_CONTENT, m_Content);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTestDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CTestDemoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_DELETE, OnButtonDelete)
	ON_BN_CLICKED(IDC_BUTTON_INSERT, OnButtonInsert)
	ON_BN_CLICKED(IDC_BUTTON_OVERWRITE, OnButtonOverwrite)
	ON_BN_CLICKED(IDC_BUTTON_ABOUT, OnButtonAbout)
	ON_BN_CLICKED(IDC_BUTTON_READ, OnButtonRead)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestDemoDlg message handlers

BOOL CTestDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	// Create test.ini.
	FileName = "test.ini";
	m_LineNum.SetWindowText("0");
	if (!file.CreateFile(FileName, CREATE_MODE_NOREBUILD))
	{
		AfxMessageBox("Create test.ini failed!");
		return FALSE;
	}

	if (!file.OpenFile(FileName, OPEN_MODE_READ))
	{
		AfxMessageBox("Open test.ini failed!");
		return FALSE;
	}
	UINT lines = file.GetLines();
	file.CloseFile();

	char temp[10];
	itoa(lines, temp, 10);
	m_TotalLines.SetWindowText(temp);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTestDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTestDemoDlg::OnButtonDelete() 
{
	// TODO: Add your control notification handler code here
	if (!file.OpenFile(FileName, OPEN_MODE_READWRITE))
	{
		AfxMessageBox("Open test.ini failed!");
		return;
	}
	CString sLine, sContent;
//	m_Content.GetWindowText(sContent);
	m_LineNum.GetWindowText(sLine);
	if (sLine.IsEmpty())
	{
		AfxMessageBox("Please enter the number of line you want to operate!");
		file.CloseFile();
		return;
	}
	file.MoveToLine(atoi(sLine.GetBuffer(sLine.GetLength())));
	file.WriteLine(sContent, WRITE_MODE_DELETE);

	char temp[10];
	itoa(file.GetLines(), temp, 10);
	file.CloseFile();
	m_Content.SetWindowText(sContent);
	m_TotalLines.SetWindowText(temp);
	
}

void CTestDemoDlg::OnButtonInsert() 
{
	// TODO: Add your control notification handler code here
	if (!file.OpenFile(FileName, OPEN_MODE_READWRITE))
	{
		AfxMessageBox("Open test.ini failed!");
		return;
	}
	CString sLine, sContent;
	m_Content.GetWindowText(sContent);
	m_LineNum.GetWindowText(sLine);
	if (sLine.IsEmpty())
	{
		AfxMessageBox("Please enter the number of line you want to operate!");
		file.CloseFile();
		return;
	}
	file.MoveToLine(atoi(sLine.GetBuffer(sLine.GetLength())));
	file.WriteLine(sContent, WRITE_MODE_INSERT);

	char temp[10];
	itoa(file.GetLines(), temp, 10);
	file.CloseFile();
	m_TotalLines.SetWindowText(temp);
}

void CTestDemoDlg::OnButtonOverwrite() 
{
	// TODO: Add your control notification handler code here
	if (!file.OpenFile(FileName, OPEN_MODE_READWRITE))
	{
		AfxMessageBox("Open test.ini failed!");
		return;
	}
	CString sLine, sContent;
	m_Content.GetWindowText(sContent);
	m_LineNum.GetWindowText(sLine);
	if (sLine.IsEmpty())
	{
		AfxMessageBox("Please enter the number of line you want to operate!");
		file.CloseFile();
		return;
	}
	file.MoveToLine(atoi(sLine.GetBuffer(sLine.GetLength())));
	file.WriteLine(sContent, WRITE_MODE_OVERWRITE);

	char temp[10];
	itoa(file.GetLines(), temp, 10);
	file.CloseFile();
	m_TotalLines.SetWindowText(temp);
	
}

void CTestDemoDlg::OnButtonAbout() 
{
	// TODO: Add your control notification handler code here
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

void CTestDemoDlg::OnButtonRead() 
{
	// TODO: Add your control notification handler code here
	if (!file.OpenFile(FileName, OPEN_MODE_READWRITE))
	{
		AfxMessageBox("Open test.ini failed!");
		return;
	}
	CString sLine, sContent;

	m_LineNum.GetWindowText(sLine);
	if (sLine.IsEmpty())
	{
		AfxMessageBox("Please enter the number of line you want to operate!");
		file.CloseFile();
		return;
	}
	file.MoveToLine(atoi(sLine.GetBuffer(sLine.GetLength())));
	file.ReadLine(sContent);
	m_Content.SetWindowText(sContent);
	char temp[10];
	itoa(file.GetLines(), temp, 10);
	file.CloseFile();
	m_TotalLines.SetWindowText(temp);	
}
